unit Clrgrid;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBTables, DB, Grids, DBGrids;

type
  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Table1: TTable;
    Table1CustNo: TFloatField;
    Table1Company: TStringField;
    Table1Addr1: TStringField;
    Table1Addr2: TStringField;
    Table1City: TStringField;
    Table1State: TStringField;
    Table1Zip: TStringField;
    Table1Country: TStringField;
    Table1Phone: TStringField;
    Table1FAX: TStringField;
    Table1TaxRate: TFloatField;
    Table1Contact: TStringField;
    Table1LastInvoiceDate: TDateTimeField;
    Table1fred: TBooleanField;
    procedure DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
    procedure Table1CalcFields(DataSet: TDataset);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
	vColor: TColor;

implementation

{$R *.DFM}

procedure TForm1.DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
  Field: TField; State: TGridDrawState);
begin
{set row-wise coloring}
	if table1.fields[13].text = 'True' then
		vColor:=clRed
  else
  	vColor:=clWhite;
  dbgrid1.canvas.brush.color:= vColor;
{fill cell with brush property}
  dbgrid1.canvas.fillrect(rect);
{column-wise font coloring}
  if field.fieldName ='State' then
  	dbgrid1.canvas.font.color:=clBlue
	else
  	dbgrid1.canvas.font.color:=clBlack;
{this 'draws' the field contents}
  dbgrid1.canvas.textout(rect.left,rect.top,field.text);
end;

procedure TForm1.Table1CalcFields(DataSet: TDataset);
begin
	if dataset.fields[5].text = 'HI' then
  	dataset.fields[13].text:='T'
  else
  	dataset.fields[13].text:='F';
end;

end.
